/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * main.cc
 * Copyright (C) 2018 mumbo <mumbo@linux-q5eg>
 * 
 * AnotherOne is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * AnotherOne is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <iostream>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_thread.h>
#include <SDL2/SDL_ttf.h>
#include <SDL2/SDL_mixer.h>
#include <stdlib.h>
#include <fstream>
#include <string>
#include <sstream> 

//Specific Defs


//General Utility
const int Objectnumber=1000;
const int Spritenumber=100;
const int Soundnumber=150;
int currentObjects=0;
int texturesUsed=0;
bool running=true;
bool FullScreen=true;
SDL_Texture* Images[Spritenumber];
TTF_Font *gFont[5];
SDL_Renderer* Renderer = NULL; //mystic thing, brings an image to the screen
float High=0;
int Counter=0;
bool EndGame=false;
int Score=0;
bool ShowMode=false;
float Divi=3;
bool CreateScoreShow=false;
bool Sound1=false;
bool Sound2=false;
bool DualShockHack=false;
int FXVolume=120;
int MuVolume=120;
int Vsync=1;
bool AA=1;
int Mode=1;
std::string PadName;
int Difficulty=2;
int Locker=0;
bool Keyboard=false;
bool Tutorial=true;
bool TutorialMade=false;
bool TutShown[10];
int Pause=0;
int PadMode=1;
SDL_GameController *controller;
bool KCodeOn=false;
int ShowTutorial(int Stage);
bool ReduceSpawnHoles=true;
bool DualShockHackSet=false;
int Table=0;
std::string ABC="ABCDEFGHIJKLMNOPQRSTUVWXYZ-abcdefghijklmnopqrstuvwxyz ";
std::string EnteredName="";
int Placed=0;
int Searcher=0;
int Zeiger=0;
//colors
		int g=255;
		int b=255;
		int r=255;	
		int gMod=1;
		
class TextBox
{
	public:
	 int W=9000;
	 int H;
	 SDL_Texture *Tex;
	 std::string content="Textbox";
	 SDL_Color Farbe={255, 255, 255};
	 SDL_Color LFarbe={255, 255, 255};
	 int Font=1;
		
		 int LFont=0;
		 std::string LString;
		  
	 int CalcMe()
	 {
		 
		 
		if(content!=LString || LFont!=Font || LFarbe.a!=Farbe.a || LFarbe.r!=Farbe.r || LFarbe.g!=Farbe.g || LFarbe.b!=Farbe.b)
		{
			LString=content;
			LFont=Font;
			LFarbe=Farbe;
			SDL_Surface* Result=NULL;
	
		

			Result=TTF_RenderText_Blended_Wrapped(gFont[Font], content.c_str(), Farbe, W);

			
		
			Tex=SDL_CreateTextureFromSurface(Renderer, Result);
			
			SDL_FreeSurface(Result);
		}
	 }
};

TextBox Boxes[50];

class Object
{
	 public:
		 int Sprite;
		 float PosX;
		 float PosY;
		 int W;
		 int H;
		 float cW, cH; //Current W/H
		 float zoom=0;
		 int cFrame=0;
		 int Frames;
		 int FrameCounter;
		 int Layer=3;
		 float FrameWait;
		 float ROT;
		 float cROT=0;
		 float Angle;
		 float Speed;
		 int MorphTime=0;
		 bool Enemy=false;
		 int Lifetime=0;
		 int TextBoxShow=0;
		 SDL_RendererFlip Flipped=SDL_FLIP_NONE;
		 
		 int Framing()
		 {
			if(Frames>0)
		{
			if(FrameCounter==FrameWait)
			{
				cFrame++;
				FrameCounter=0;
				if(cFrame>Frames)cFrame=0;
			}
			else
			{
				FrameCounter++;
			}
		}
		}
		//Speeding
		//Can you -tell me- still remember, the Decembers fucking freeze, when the ice...
		int Move()
		{
		if(Speed!=0)
		{
		float cAngle=((Angle*M_PI)/180);
			PosX=PosX+(cos(cAngle)*Speed);
			PosY=PosY+(sin(cAngle)*Speed);
		}
		}
		//Rotation
		//You spin me right-round baby, right round, like a record baby, right, right, round round!
		int RoZo()
		{
		if(ROT!=0)
		{
			cROT=cROT+ROT;
		}
		if(zoom!=0)
		{
		float s1=cW;
		float s2=cH;
		cW=cW*(zoom+(High/100));
		cH=cH*(zoom+(High/100));
		PosX=PosX-((cW-s1)/2);
		PosY=PosY-((cH-s2)/2);
		if(cW>50 && Tutorial==true)
		 ShowTutorial(2);
		}
		}
		
		int Perish()
		{
		int r=0;
	
		if(MorphTime>0)
		{
			MorphTime--;
			if(MorphTime==1)
			{
				if(Sprite==3)
				{
				Sprite=4;
				g=g-30;
				b=b-30;
				if(Tutorial==true)
				ShowTutorial(4);
				Counter++;
				High=High/(1+Divi);
				Divi=Divi*0.995;
				zoom=0;
				}
				if(Sprite==2)
				{
				Sprite=3;
				if(Tutorial==true)
				ShowTutorial(3);
				g=g-15;
				b=b-15;
				
				MorphTime=(1000+(rand()%1000))/(1+High);
				}
				if(g<=0)
				{
					EndGame=true;
					
				}

			}
		}
		if(Lifetime>0)
		{
			Lifetime--;
			if(Lifetime==0)
			{
			TextBoxShow=0;
			 r=-1;
			}
		}
		return r;
		}
		//Draw Object to Renderer
		
		int Draw(SDL_Renderer* Rend)
		{
	    SDL_Rect Re, Wri;
		Re.x=cFrame*W;
		Re.y=0;
		Re.h=H;
		Re.w=W;
		Wri.x=PosX;
		Wri.y=PosY;
		Wri.h=cH;
		Wri.w=cW;
		SDL_RenderCopyEx( Rend, Images[Sprite], &Re, &Wri, cROT, NULL, Flipped);
				if(TextBoxShow>0) //fonting
				{
				
				 Boxes[TextBoxShow].CalcMe();
				Wri.x=PosX;
				Wri.y=PosY;
				int w, h;
				SDL_QueryTexture(Boxes[TextBoxShow].Tex, NULL, NULL, &w, &h);
				Wri.w=w;
				Wri.h=h;
				 SDL_RenderCopyEx( Renderer, Boxes[TextBoxShow].Tex, NULL, &Wri, cROT, NULL, SDL_FLIP_NONE);	
				}
		}
 };
 
 
 
 const int stacksize=3000;
 
 class ObjectStack
 {
	 public:
	 
	 Object Ostack[stacksize];
	 int sNumber=0;
	 
	 int Create(Object Ob)
	 {
		 sNumber++;
		 Ostack[sNumber]=Ob;
	 }
	 
	 int Delete(int N)
	 {
		for(int i=N; i<sNumber+1; i++)
		{
		 Ostack[i]=Ostack[i+1];
		}
		sNumber--;
	 }
	 int Man()
	 {
		 for(int i=0; i<sNumber+1; i++)
		 {
			 Ostack[i].Framing();
			 Ostack[i].Move();
			 Ostack[i].RoZo();
			 int t=Ostack[i].Perish();
			 if(t==-1)
			 {
				Delete(i);
			 }
			 	if(((Ostack[i].PosX+(Ostack[i].cW/2)<0) || (Ostack[i].PosX+(Ostack[i].cW/2)>1920) || (Ostack[i].PosY+(Ostack[i].cH/2)<0)  || (Ostack[i].PosY+(Ostack[i].cH/2)>1050))) 
			 	{
					 if(Ostack[i].Sprite==3)
					 {
						 	g=g+15;
							b=b+15;
							
							
					 }
					 if(Ostack[i].Sprite==4)
					 {
						 	g=g+45;
							b=b+45;
							Counter--;
							
					 }
					 Delete(i);
				}
		 }
	 }
	 int Rend(SDL_Renderer* Rere)
	 {
		for(int l=0; l<6; l++)
		{
		 for(int i=0; i<sNumber+1; i++)
		 {
			if(l==Ostack[i].Layer)
			Ostack[i].Draw(Rere);
		 }
		}
	 }
	 
	 int Clear()
	 {
		
		for(int i=1; i<sNumber+1; i++)
		{
		 Delete(i);
		 
		}
		Ostack[1]=Ostack[2];
		sNumber=0;
		for(int i=0; i<stacksize; i++)
		{
			Ostack[i].Angle=0;
			Ostack[i].Enemy=false;
			Ostack[i].Flipped=SDL_FLIP_NONE;
			Ostack[i].FrameCounter=0;
			Ostack[i].FrameWait=0;
			Ostack[i].Frames=0;
			Ostack[i].H=0;
			Ostack[i].Layer=0;
			Ostack[i].Lifetime=0;
			Ostack[i].MorphTime=0;
			Ostack[i].PosX=0;
			Ostack[i].PosY=0;
			Ostack[i].ROT=0;
			Ostack[i].Speed=0;
			Ostack[i].Sprite=0;
			Ostack[i].TextBoxShow=0;
			Ostack[i].W=0;
			Ostack[i].cFrame=0;
			Ostack[i].cH=0;
			Ostack[i].cW=0;
			Ostack[i].zoom=0;
		}
		
		
	 }
	 
	 int Shoot(int x, int y)
	 {
		 int Helper=0;
		 if(Difficulty==1)
		  Helper=4;
		  if(Difficulty==2)
		  Helper=2;
		 for(int i=0; i<sNumber+1; i++)
		 {
		 if(Ostack[i].Enemy==true)
		 {
			 if(((Ostack[i].PosX-Helper)<x)&&((Ostack[i].PosX+Ostack[i].cW+Helper)>x)&&((Ostack[i].PosY-Helper)<y)&&((Ostack[i].PosY+Ostack[i].cH+Helper)>y)) //if(((((Ostack[i].PosX-Helper)<x)&&((Ostack[i].PosX+Ostack[i].cW+Helper)>x)&&((Ostack[i].PosY-Helper)<y)&&((Ostack[i].PosY+Ostack[i].cH+Helper)>y)) )|| ((Ostack[i].PosX+(Ostack[i].W/2)<0) || (Ostack[i].PosX+(Ostack[i].W/2)>1920) || (Ostack[i].PosY+(Ostack[i].H/2)<0)  || (Ostack[i].PosY+(Ostack[i].H/2)>1050))) 
			 {
				if(Ostack[i].cW>(100-(25*(Difficulty-1))))
				 {
					 int t1=Ostack[i].cW;
					 int t2=Ostack[i].cH;
					 Ostack[i].cW=Ostack[i].cW/2;
					 Ostack[i].cH=Ostack[i].cH/2;
					 Ostack[i].PosX=Ostack[i].PosX+((t1-Ostack[i].cW)/2);
					 Ostack[i].PosY=Ostack[i].PosY+((t2-Ostack[i].cH)/2);
					 
				 }
				 else
				 {
					 	 if(Ostack[i].Sprite==3)
					 {
						 	g=g+15;
							b=b+15;
							
							
					 }
					 if(Ostack[i].Sprite==4)
					 {
						 	g=g+45;
							b=b+45;
							Counter--;
							
					 }
					 if(KCodeOn==false)
					  High=High+(0.02*Ostack[i].Sprite);
					  else
					  High=High+(0.06*Ostack[i].Sprite);
					  Score=Score+(((Ostack[i].Sprite*10)*(1+High))/Divi);
					  //std::cout << "H: " << High << " Divi " << Divi << " Score: " << Score <<std::endl;
				Delete(i);
			}
			 }
		 }
		 }
	 }
 };

ObjectStack Stack;
ObjectStack interface;

class Player
{
	public:
		float AxX;
		float AxY;
		int ObjectID=0;
		bool HatUp;
		int Axis[10];
		int Buttons[5];
		bool Keys[13];
		bool Keylock[13];
};
//Playerdef
Player Players[10];

Object Objectlist[Objectnumber];


int KCode()
{
SDL_Surface *s;
s = SDL_CreateRGBSurface(0, 100, 100, 32, 0, 0, 0, 0);
SDL_UnlockSurface(s);
/* Filling the surface with red color. */
SDL_FillRect(s, NULL, SDL_MapRGB(s->format, 0, 0, 255));
Images[2]= SDL_CreateTextureFromSurface(Renderer, s);
SDL_FillRect(s, NULL, SDL_MapRGB(s->format, 0, 0, 51));
Images[3]= SDL_CreateTextureFromSurface(Renderer, s);
SDL_LockSurface(s);
KCodeOn=true;
}

Mix_Chunk *Sounds [Soundnumber];
//General Defs
SDL_DisplayMode DMode;
SDL_Joystick* Pad1[10];
SDL_Haptic* ControllerHaptic[10];
SDL_Window* Window = NULL;
std::string speicher;

SDL_Surface* CurrentSurface = NULL;
SDL_Surface* ScreenSurface = NULL; 
SDL_Rect Reader;
SDL_Rect Writer;
SDL_Event event;


Mix_Music *Music[20]; 


int LoadMusic()
{
	int newCounter=0;
	
	std::ifstream file;
	std::string str;
	file.open("Music.txt");
	while (std::getline(file, str))
		{
		//std::cout << "Line Loaded" << std::endl;
			char* writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			newCounter++;
			Music[newCounter]=Mix_LoadMUS(writable);
		delete[] writable;
			
		
		}
		file.close();
		
	return newCounter;
}

bool MusicIndexed=false;
int MusicAvaible=0;
int MusicMan()
{
	
	if(MusicIndexed==false)
	{
	 MusicIndexed=true;
	 MusicAvaible=LoadMusic();
	// std::cout << MusicAvaible << " Tracks avaible" << std::endl;
    }
    
 
    if(Mix_PlayingMusic()==0)
     {
	  Mix_VolumeMusic(MuVolume);
	  int Take=0;
	  if(MusicAvaible>0)
	  {
	  while(Take==0)
	  Take=rand()%(MusicAvaible+1);
	  }
	  Mix_PlayMusic(Music[Take], 1);
	 } 
	
}

int iniSDL(bool AntiA)
{

//Ini Video
	
	
	 if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) { printf( "SDL konnte nicht initialisiert werden: %s\n", SDL_GetError() ); }
		else { 
		 if( !SDL_SetHint( SDL_HINT_RENDER_SCALE_QUALITY, "1" ) ) { printf( "Warning: Linear texture filtering not enabled!" ); }
		if(AntiA==true)
		{
		SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
		SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 1);
	    SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, 2);
		SDL_GL_SetAttribute(SDL_GL_ACCELERATED_VISUAL, 1);
		}
		  for(int i = 0; i < SDL_GetNumVideoDisplays(); ++i)
		{
		
		int should_be_zero = SDL_GetCurrentDisplayMode(i, &DMode);

		 if(should_be_zero != 0)
  	
 	    SDL_Log("SDL-Fehler bei der Ausgabe #%d: %s", i, SDL_GetError());

		 else
 	   

		
	   SDL_Log("Anzeige #%d: Modus: %dx%dpx @ %dhz. \n", i, DMode.w, DMode.h, DMode.refresh_rate);
		  }
 
		}
if(FullScreen==true)
			  Window=SDL_CreateWindow("Meditation 5", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_FULLSCREEN | SDL_WINDOW_OPENGL ); 
		else
			Window=SDL_CreateWindow("editation 5", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_OPENGL ); 
		if(Vsync==true)
		Renderer = SDL_CreateRenderer( Window, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC );
		else
		Renderer = SDL_CreateRenderer( Window, -1, SDL_RENDERER_ACCELERATED); 
		
		 SDL_RenderSetLogicalSize(Renderer, 1920, 1080);
		 ScreenSurface = SDL_GetWindowSurface( Window );
		 if( TTF_Init() == -1 ) { printf( "SDL_ttf could not initialize! SDL_ttf Error: %s\n", TTF_GetError() ); }
		   gFont[1]=TTF_OpenFont( "NegativeSpace.ttf", 96 );
		   gFont[2]=TTF_OpenFont( "NegativeSpace.ttf", 40 );
		   gFont[3]=TTF_OpenFont( "NegativeSpace.ttf", 250 );
		if(FullScreen==true)
			SDL_SetWindowFullscreen(Window, SDL_WINDOW_FULLSCREEN);
		
//ini Sound!
 if( Mix_OpenAudio( 44100, MIX_DEFAULT_FORMAT, 2, 2048 ) < 0 ) { printf( "Ton-Wiedergabe nicht möglich :(: %s\n", Mix_GetError() );}
SDL_ShowCursor(0);
//ini Joystick!
if(PadMode==1)
{
SDL_InitSubSystem(SDL_INIT_GAMECONTROLLER);
SDL_SetHint(SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS,"1");

for (int i = 0; i < SDL_NumJoysticks(); ++i) {
    if (SDL_IsGameController(i)) {
        controller = SDL_GameControllerOpen(i);
        if (controller) {
			std::cout << "Initialised Gamepad as GameController, Name " << SDL_GameControllerName(controller) << std::endl;
			if(DualShockHackSet==false)
			{
			bool Tester=false;
			std::string stupidDualShockWorkarround (SDL_GameControllerName(controller));
			std::string stupidDualShockWorkarround2 ("PS4");

			if (stupidDualShockWorkarround.find(stupidDualShockWorkarround2) != std::string::npos) {
			Tester=true;
			} 
			stupidDualShockWorkarround2="PS3";

			if (stupidDualShockWorkarround.find(stupidDualShockWorkarround2) != std::string::npos) {
			Tester=true;
			} 
			stupidDualShockWorkarround2="PS2";

			if (stupidDualShockWorkarround.find(stupidDualShockWorkarround2) != std::string::npos) {
			Tester=true;
			} 
			stupidDualShockWorkarround2="Shock";

			if (stupidDualShockWorkarround.find(stupidDualShockWorkarround2) != std::string::npos) {
			Tester=true;
			} 
			if(Tester==true)
			  DualShockHack=true;
		  }
			  //std::cout << "Dual Shock Hack " << DualShockHack << std::endl;
			if(SDL_GameControllerMapping(controller)==NULL)
			{
				//std::cout << "No Mapping avaible. Using Fallback Mode" << std::endl;
				PadMode=2;
			}
			else 
			//std::cout << "Mapping avaible" << SDL_GameControllerMapping(controller) << std::endl;
            break;
        } else {
            //fprintf(stderr, "Could not open gamecontroller, trying Fallback Mode", i, SDL_GetError());
            PadMode=2;
        }
    }
}
if(SDL_NumJoysticks()<1)
 PadMode=2;
}
if(PadMode==2)
{
	   SDL_InitSubSystem(SDL_INIT_JOYSTICK);
		SDL_SetHint(SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS,"1");
	 if( SDL_NumJoysticks() < 1 ) 
		{ 
			  
			
			printf( "Kein Gamepad!\n" ); 
				 PadName="NoPad";
		Keyboard=true;
		 Mode=3;
		} 
		else 
		{ 
			for(int i=0; i<SDL_NumJoysticks(); i++)
			{
			

			//Load joystick 
			SDL_JoystickEventState(SDL_ENABLE);
			Pad1[i] = SDL_JoystickOpen( i ); 
			ControllerHaptic[i] = SDL_HapticOpenFromJoystick( Pad1[i] ); 
						if( ControllerHaptic[i] == NULL ) 
			{ printf( "Kein Force-Feedback %s\n", SDL_GetError() ); } 
			else { 
				
				//Get initialize rumble 
				if( SDL_HapticRumbleInit( ControllerHaptic[i] ) < 0 ) { printf( "Warning: Unable to initialize rumble! SDL Error: %s\n", SDL_GetError() ); } }
			 printf("Joystick gefunden 0\n");
        printf("Name: %s\n", SDL_JoystickNameForIndex(i));
        printf("Achsen: %d\n", SDL_JoystickNumAxes(Pad1[i]));
        printf("Buttons: %d\n", SDL_JoystickNumButtons(Pad1[i]));
        printf("Baelle: %d\n", SDL_JoystickNumBalls(Pad1[i]));
		SDL_ShowCursor(0);
			
		
			if( Pad1[i] == NULL ) 
			{ 
				printf( "Gamepad konnte nicht angesteuert werden: %s\n", SDL_GetError() ); 
			} 
		}
		if(Pad1[0]!=NULL)
		{
		const char* Joy1=SDL_JoystickNameForIndex(0);
		std::string t(Joy1);
		//std::cout << "Pad 0 " << t << std::endl;
		if(PadName!=t)
		{
		// std::cout << "Need to Setup Gamepad" << std::endl;
		 Mode=3;
		 PadName=t;
		}
		}
		else
		{
	
		}
		}
	}
}

SDL_Texture* loadTexture( std::string path ) { 
	SDL_Texture* newTexture = NULL; 
		SDL_Surface* loadedSurface = IMG_Load( path.c_str() ); 
	if( loadedSurface == NULL ) { printf( "Unable to load image %s! SDL_image Error: %s\n", path.c_str(), IMG_GetError() ); } else { 
		newTexture = SDL_CreateTextureFromSurface( Renderer, loadedSurface ); if( newTexture == NULL ) { printf( "Unable to create texture from %s! SDL Error: %s\n", path.c_str(), SDL_GetError() ); } 
		
		SDL_FreeSurface( loadedSurface ); } return newTexture; }

int loadImages(char* bildliste)
{
			texturesUsed=1;
			std::ifstream file;
			file.open(bildliste);
			std::string str; 
			while (std::getline(file, str))
			{
  			   Images[texturesUsed] = loadTexture( str );
			   texturesUsed++;
			 }
			file.close();
		
};

int LoadSounds()
{
	int newCounter=0;
	
	std::ifstream file;
	std::string str;
	file.open("Sounds.txt");
	while (std::getline(file, str))
		{
		//std::cout << "Line Loaded" << std::endl;
			char* writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			newCounter++;
			Sounds[newCounter]=Mix_LoadWAV(writable);
		delete[] writable;
			//std::cout << Stages[newCounter] <<"\n";
		
		}
		file.close();
		
	
		}


int WriteSettings()
{
  std::ofstream myfile;
  myfile.open ("Settings.txt");
  myfile << "Antialiasing\n";
  myfile << AA <<"\n";
  myfile << "Fullscreen\n";
  myfile << FullScreen <<"\n";
  myfile << "Vsync\n";
  myfile << Vsync <<"\n";
  myfile << "MuVolume\n";
  myfile << MuVolume <<"\n";
  myfile << "FXVolume\n";
  myfile << FXVolume <<"\n";
   myfile << "Difficulty\n";
  myfile << Difficulty <<"\n";
  myfile << "PadName\n";
  myfile << PadName <<"\n";
   myfile << "Tutorial\n";
  myfile << Tutorial <<"\n";
  myfile << "Ax1\n";
  myfile << Players[1].Axis[1] <<"\n";
   myfile << "Ax2\n";
  myfile << Players[1].Axis[2] <<"\n";
    myfile << "Ax3\n";
  myfile << Players[1].Axis[3] <<"\n";
    myfile << "Ax4\n";
  myfile << Players[1].Axis[4] <<"\n";
    myfile << "B1\n";
  myfile << Players[1].Buttons[1] <<"\n";
     myfile << "B2\n";
  myfile << Players[1].Buttons[2] <<"\n";
   myfile << "B3\n";
  myfile << Players[1].Buttons[3] <<"\n";
  if(DualShockHackSet==true)
  {
  myfile << "DualShockHack";
  myfile << DualShockHack <<"\n";
  }
  myfile.close();
  return 0;
}

int ScoreTable[4][12];
std::string ScoreTableNames[4][12];

int ScoreTableB[4][12];
std::string ScoreTableNamesB[4][12];

int loadScore(char* mainfile)
{
			std::ifstream file;
	
			std::string str;
	
			file.open(mainfile);
			int Score1=0;
			int Score2=0;
			int Score3=0;
			int Score1B=0;
			int Score2B=0;
			int Score3B=0;
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			
			if(speicher=="ScoreL1Name"){Score1++; ScoreTableNames[1][Score1]=writable;}
			if(speicher=="ScoreL1Score"){ScoreTable[1][Score1]=atoi(str.c_str());}
			if(speicher=="ScoreL2Name"){Score2++; ScoreTableNames[2][Score2]=writable;}
			if(speicher=="ScoreL2Score"){ScoreTable[2][Score2]=atoi(str.c_str());}
			if(speicher=="ScoreL3Name"){Score3++; ScoreTableNames[3][Score3]=writable;}
			if(speicher=="ScoreL3Score"){ScoreTable[3][Score3]=atoi(str.c_str());}
			
			if(speicher=="ScoreL1BName"){Score1B++; ScoreTableNamesB[1][Score1B]=writable;}
			if(speicher=="ScoreL1BScore"){ScoreTableB[1][Score1B]=atoi(str.c_str());}
			if(speicher=="ScoreL2BName"){Score2B++; ScoreTableNamesB[2][Score2B]=writable;}
			if(speicher=="ScoreL2BScore"){ScoreTableB[2][Score2B]=atoi(str.c_str());}
			if(speicher=="ScoreL3BName"){Score3B++; ScoreTableNamesB[3][Score3B]=writable;}
			if(speicher=="ScoreL3BScore"){ScoreTableB[3][Score3B]=atoi(str.c_str());}
			 
				delete[] writable;
				speicher=str;
			}
			for(int i=1; i<3; i++)
			{
				for(int i2=1; i2<11; i2++)
				{
					//std::cout << "Table " << " Place " << i2 << ScoreTableNames[i][i2] << " with " << ScoreTable[i][i2] << std::endl;
				}
			}
		file.close();	
}

int SaveScores()
{
  std::ofstream myfile;
  myfile.open ("Scores.txt");
  for(int i=1; i<11; i++)
  {
  myfile << "ScoreL1Name\n";
  myfile << ScoreTableNames[1][i] <<"\n";  
  myfile << "ScoreL1Score\n";
  myfile << ScoreTable[1][i] <<"\n"; 
  }
  
  for(int i=1; i<11; i++)
  {
  myfile << "ScoreL2Name\n";
  myfile << ScoreTableNames[2][i] <<"\n";  
  myfile << "ScoreL2Score\n";
  myfile << ScoreTable[2][i] <<"\n"; 
  }
  
  for(int i=1; i<11; i++)
  {
  myfile << "ScoreL3Name\n";
  myfile << ScoreTableNames[3][i] <<"\n";  
  myfile << "ScoreL3Score\n";
  myfile << ScoreTable[3][i] <<"\n"; 
  }
  
  for(int i=1; i<11; i++)
  {
  myfile << "ScoreL1BName\n";
  myfile << ScoreTableNamesB[1][i] <<"\n";  
  myfile << "ScoreL1BScore\n";
  myfile << ScoreTableB[1][i] <<"\n"; 
  }
  
    for(int i=1; i<11; i++)
  {
  myfile << "ScoreL2BName\n";
  myfile << ScoreTableNamesB[2][i] <<"\n";  
  myfile << "ScoreL2BScore\n";
  myfile << ScoreTableB[2][i] <<"\n"; 
  }
  
    for(int i=1; i<11; i++)
  {
  myfile << "ScoreL3BName\n";
  myfile << ScoreTableNamesB[3][i] <<"\n";  
  myfile << "ScoreL3BScore\n";
  myfile << ScoreTableB[3][i] <<"\n"; 
  }
      
    
  
  myfile.close();
  return 0;
}

int loadSettings(char* mainfile)
{
			std::ifstream file;
	
			std::string str;
	
			file.open(mainfile);
			int HilfsInteger=0; 
			int HilfsInteger2=0; 
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="Antialiasing"){AA=atoi(str.c_str());}
			if(speicher=="Fullscreen"){FullScreen=atoi(str.c_str());}
			if(speicher=="Vsync"){Vsync=atoi(str.c_str());}
			if(speicher=="Difficulty"){Difficulty=atoi(str.c_str());}
			if(speicher=="FXVolume"){FXVolume=atoi(str.c_str());}
			if(speicher=="MuVolume"){MuVolume=atoi(str.c_str());}
			if(speicher=="PadName"){PadName=str.c_str();}
			if(speicher=="Tutorial"){Tutorial=atoi(str.c_str());}
			if(speicher=="Ax1"){Players[1].Axis[1]=atoi(str.c_str());}
			if(speicher=="Ax2"){Players[1].Axis[2]=atoi(str.c_str());}
			if(speicher=="Ax3"){Players[1].Axis[3]=atoi(str.c_str());}
			if(speicher=="Ax4"){Players[1].Axis[4]=atoi(str.c_str());}
			if(speicher=="B1"){Players[1].Buttons[1]=atoi(str.c_str());}
			if(speicher=="B2"){Players[1].Buttons[2]=atoi(str.c_str());}
			if(speicher=="B3"){Players[1].Buttons[3]=atoi(str.c_str());}
			if(speicher=="DualShockHack"){DualShockHack=atoi(str.c_str()); DualShockHackSet=true;}
				delete[] writable;
				speicher=str;
			}
		file.close();	
}

int KCodeCount=0;
int EnterKCode(int i)
{
bool ok=false;
bool active=true;
if(i==1 && (KCodeCount==0 || KCodeCount==1) && active==true)
{
 ok=true;
 active=false;
 KCodeCount++;
 //std::cout << "KCode " << KCodeCount << std::endl;
}

if(i==2 && (KCodeCount==2 || KCodeCount==3) && active==true)
{
 ok=true;
 active=false;
 KCodeCount++;
 //std::cout << "KCode " << KCodeCount << std::endl;
}

if(i==3 && (KCodeCount==4 || KCodeCount==6) && active==true)
{
 ok=true;
 active=false;
 KCodeCount++;
 //std::cout << "KCode " << KCodeCount << std::endl;
}

if(i==4 && (KCodeCount==5 || KCodeCount==7) && active==true)
{
 ok=true;
 active=false;
 KCodeCount++;
 //std::cout << "KCode " << KCodeCount << std::endl;
}
if(KCodeCount==8 && KCodeOn==false)
	KCode();
if(ok==false)
 {

 KCodeCount=0;
 //std::cout << "KCode erased" << std::endl;
}

}
	
int createScreen()
{
Object Screen;
Screen.PosX=0;
Screen.PosY=0;
Screen.Layer=3;
Screen.Lifetime=2;
Screen.Sprite=5;
Screen.H=100;
Screen.W=100;
Screen.cW=1920;
Screen.cH=1080;
Stack.Create(Screen);
}

int ShowTutorial(int Stage)
{
if(Tutorial==true)
{



if(Stage==1 && TutShown[Stage]==false)
	{
		createScreen();
		Pause=1000;
		Objectlist[4].PosX=100;
		Objectlist[4].PosY=150;
		Objectlist[4].Layer=4;
		Objectlist[4].TextBoxShow=2;
		Objectlist[4].Lifetime=2;
		Boxes[2].content="Welcome to Meditation 5! Use your sticks to aim and the shoulder buttons to fire. Be advised that holding your fire may slightly increase the spawnrate of enemies.";
		Boxes[2].Farbe={255, 255, 255};
		Boxes[2].W=1700;
		Stack.Create(Objectlist[4]);
	}
if(Stage==2 && TutShown[Stage]==false)
	{
		createScreen();
		Pause=1300;
		Objectlist[4].PosX=100;
		Objectlist[4].PosY=150;
		Objectlist[4].Layer=3;
		Objectlist[4].TextBoxShow=2;
		Objectlist[4].Lifetime=2;
		Boxes[2].content="Please take notice of this red square. Fire at it to reduce its size. If a square drops under a certain size, it will disappear. You will be awarded points and your multiplier increases. But be careful: the more enemies you shoot, the more enemies appear! Stay on guard!";
		Boxes[2].Farbe={255, 255, 255};
		Boxes[2].W=1700;
		Stack.Create(Objectlist[4]);
	}
if(Stage==3 && TutShown[Stage]==false)
	{
		createScreen();
		Pause=1300;
		Objectlist[4].PosX=100;
		Objectlist[4].PosY=150;
		Objectlist[4].Layer=3;
		Objectlist[4].TextBoxShow=2;
		Objectlist[4].Lifetime=2;
		Boxes[2].content="If you leave a square unattended for too long, it might turn darker. Killing a dark square will provide you with more points and multiplier. But be careful: Every darkended square shifts the background color more towards red - a completely red background means game over!";
		Boxes[2].Farbe={255, 255, 255};
		Boxes[2].W=1700;
		Stack.Create(Objectlist[4]);
	}
if(Stage==4 && TutShown[Stage]==false)
	{
		createScreen();
		Pause=1300;
		Objectlist[4].PosX=100;
		Objectlist[4].PosY=150;
		Objectlist[4].Layer=3;
		Objectlist[4].TextBoxShow=2;
		Objectlist[4].Lifetime=2;
		Boxes[2].content="Darkened squares will eventually turn black. For every black square that appears, your multiplier will be reduced, but the number of points you aquire increases. This effect weakens every time. The black squares themselves are more valuable than darkended enemies, but also redden the background faster.";
		Boxes[2].Farbe={255, 255, 255};
		Boxes[2].W=1700;
		Tutorial=false;
		TutorialMade=true;
		Stack.Create(Objectlist[4]);
	}
	
	TutShown[Stage]=true;
}
}

int GraphicHandler(void *in)
{
	int starter=SDL_GetTicks();
	while(running==true)
	{
	
	if(KCodeOn==false)
	{ 
	if(g>0)
	SDL_SetRenderDrawColor(Renderer, r, g, b, 255);
	}
	else
	if(g>0)
	SDL_SetRenderDrawColor(Renderer, b, g, r, 255);
	


	SDL_RenderClear( Renderer );
	/*for(int i=0; i<Stack.sNumber; i++)
	{
		
	Reader.x=Stack.Ostack[i].cFrame*Stack.Ostack[i].W;
	Reader.y=0;
	Reader.h=Stack.Ostack[i].H;
	Reader.w=Stack.Ostack[i].W;
	Writer.x=Stack.Ostack[i].PosX;
	Writer.y=Stack.Ostack[i].PosY;
	Writer.h=Stack.Ostack[i].H;
	Writer.w=Stack.Ostack[i].W;
	SDL_RenderCopyEx( Renderer, Images[Stack.Ostack[i].Sprite], &Reader, &Writer, Stack.Ostack[i].cROT, NULL, SDL_FLIP_NONE); 
	} */
	Stack.Rend(Renderer);
	interface.Rend(Renderer);
	SDL_RenderPresent( Renderer );
	starter=SDL_GetTicks()-starter;
	if(starter<16)SDL_Delay(16-starter);
	starter=SDL_GetTicks();
	}
	return 0;
}

int PlayerLogic()
{
	

}

int SpawnEnemy(int chance)
{
	int ra=rand()%200;
	bool SpeedUp=false;
	if(Stack.sNumber<5 && ReduceSpawnHoles==true)
	{
	 chance=chance*2;
	 SpeedUp=true;
	}
	if(Stack.sNumber>15 && ReduceSpawnHoles==true && Difficulty<3)
	 chance=chance/2;
	if(ra<chance)
	{
	Objectlist[2].PosX=200+(rand()%1520);
	Objectlist[2].PosY=100+(rand()%860);
	Objectlist[2].W=100;
	Objectlist[2].H=100;
	Objectlist[2].cW=0.01;
	Objectlist[2].cH=0.01;
	if(SpeedUp==true)
	{
	float addo=(rand()%200)/100;
	Objectlist[2].cW=0.01+addo;
	Objectlist[2].cH=0.01+addo;	
	}
	Objectlist[2].Enemy=true;
	Objectlist[2].zoom=1.005;
	Objectlist[2].Layer=1;
	Objectlist[2].Sprite=2;
	Objectlist[2].Lifetime=0;
	Objectlist[2].MorphTime=2000+(rand()%3000);
	if(High>0)
	Objectlist[2].MorphTime=Objectlist[2].MorphTime/(1+(High));
	Stack.Create(Objectlist[2]);
	}
}

int CreateLevel()
{

	
	
	//g--;
	if(ShowMode==true)
	{
	Objectlist[2].PosX=(1920/2)-0.96;
	Objectlist[2].PosY=(1080/2)-0.54;
	Objectlist[2].W=1920;
	Objectlist[2].H=1080;
	Objectlist[2].cW=0.1920;
	Objectlist[2].cH=0.1080;
	Objectlist[2].Layer=3;
	Objectlist[2].Enemy=false;
	Objectlist[2].zoom=1.01;
	Objectlist[2].Lifetime=1500;
	Objectlist[2].Frames=0;
	Objectlist[2].MorphTime=0;
	Objectlist[2].FrameWait=20;
	int r=rand()%100;
	if(r>30)
	{
		Objectlist[2].Flipped=SDL_FLIP_HORIZONTAL;
	}
	else
	Objectlist[2].Flipped=SDL_FLIP_NONE;
	Objectlist[2].Sprite=5+(rand()%9);



	
	
	Stack.Create(Objectlist[2]); 
	}
	SpawnEnemy(15+(High*5));
}


int IniGame()
{
r=255;
g=255;
b=255;
Stack.Clear();
interface.Clear();
Score=0;
High=0;
Divi=3;
CreateScoreShow=false;
EndGame=false;
Counter=0;
Sound1=false;
Sound2=false;
Mix_HaltChannel(-1);
Object Visier;
Visier.Sprite=1;
Visier.PosX=0;
Visier.PosY=0;
Visier.H=100;
Visier.W=100;
Visier.cH=100;
Visier.cW=100;

interface.Create(Visier);
interface.Create(Visier);
if(Keyboard==true)
{
	interface.Ostack[1].PosX=480-50;
	interface.Ostack[1].PosY=540-50;
	interface.Ostack[2].PosX=1440-50;
	interface.Ostack[2].PosY=540-50;
}
ShowTutorial(1);
Mode=1;

}

int MenuMode=1;
int Menu=1;
bool MenuS=false;
bool MenuS1=false;
bool MenuS2=false;
int FreshStart=4000; 


int IniMenu(bool Options=false)
{

if(Mode!=3)
{
Stack.Clear();
interface.Clear();
Score=0;
Table=0;
High=0;
Divi=3;
CreateScoreShow=false;
EndGame=false;
Counter=0;
Sound1=false;
Sound2=false;
Mix_HaltChannel(-1);
if(Options==false)
{
if(FreshStart>3000)
{
Objectlist[4].PosX=100;
Objectlist[4].PosY=100;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=2;
Boxes[2].content="EPILEPSY WARNING! This game contains rapidly changing colors and flashes, thus it might be dangerous to people with photosensitive epilepsy, even if they did not experience problems in the past. If you experience problems such as dizziness, disorientation, muscle- or eye-twitching, or any other symptoms while playing, stop playing the game immediately. Use the left stick and the left shoulder button to navigate the main menu.";
Boxes[2].Farbe={0, 0, 0};
Boxes[2].W=1800;
Boxes[2].Font=1;
Stack.Create(Objectlist[4]);



}
else if(FreshStart>0)
{
Objectlist[4].PosX=400;
Objectlist[4].PosY=100;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=3;
Boxes[3].content="Meditation 5";
Boxes[3].Farbe={0, 0, 0};
Boxes[3].W=1800;
Boxes[3].Font=3;
Stack.Create(Objectlist[4]);
	
Objectlist[4].PosX=100;
Objectlist[4].PosY=800;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=2;
Boxes[2].content="Meditation 5 by Thunder Perfect Witchcraft, 2020. Do not share without permission. Negative Space Font by Logan Kruger. See folder for credits. Medidation 5 uses SDL2. SDL 2 is licensed with zlib-license. See folder for further information. Libstdc++, LibGCC and the medialibs are free software under the GPL. See the folder for further information";
Boxes[2].Farbe={0, 0, 255};
Boxes[2].W=1800;
Boxes[2].Font=2;
Stack.Create(Objectlist[4]);	
}
else
{
MenuMode=1;
Objectlist[4].PosX=700;
Objectlist[4].PosY=300;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=2;
Boxes[2].content="Start Game";
Boxes[2].Farbe={0, 0, 0};
Boxes[2].Font=1;
Stack.Create(Objectlist[4]);

Objectlist[4].PosX=700;
Objectlist[4].PosY=400;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=3;
Boxes[3].content="Options";
Boxes[3].Farbe={0, 0, 0};
Boxes[3].Font=1;
Stack.Create(Objectlist[4]);

Objectlist[4].PosX=700;
Objectlist[4].PosY=500;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=4;
Boxes[4].content="Exit";
Boxes[4].Farbe={0, 0, 0};
Stack.Create(Objectlist[4]);
}
}
else
{
MenuMode=2;
Menu=1;
Objectlist[4].PosX=700;
Objectlist[4].PosY=300;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=2;
Boxes[2].content="Difficulty";
Boxes[2].Farbe={0, 0, 0};
Stack.Create(Objectlist[4]);

Objectlist[4].PosX=700;
Objectlist[4].PosY=400;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=3;
Boxes[3].content="Fullscreen";
Boxes[3].Farbe={0, 0, 0};
Stack.Create(Objectlist[4]);

Objectlist[4].PosX=700;
Objectlist[4].PosY=500;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=4;
Boxes[4].content="Show Tutorial";
Boxes[4].Farbe={0, 0, 0};
Stack.Create(Objectlist[4]);

Objectlist[4].PosX=700;
Objectlist[4].PosY=600;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=5;
Boxes[5].content="Sounds";
Boxes[5].Farbe={0, 0, 0};
Stack.Create(Objectlist[4]);

Objectlist[4].PosX=700;
Objectlist[4].PosY=700;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=6;
Boxes[6].content="Volume ";
Boxes[6].Farbe={0, 0, 0};
Stack.Create(Objectlist[4]);

Objectlist[4].PosX=700;
Objectlist[4].PosY=800;
Objectlist[4].Layer=3;
Objectlist[4].TextBoxShow=7;
Boxes[7].content="Back";
Boxes[7].Farbe={0, 0, 0};
Stack.Create(Objectlist[4]);
}


Mode=2;
}
}






int CheckKeyboard()
{
const Uint8 *state = SDL_GetKeyboardState(NULL);
if(state[SDL_SCANCODE_W])
{
	Players[1].Keys[1]=true;
}
else
{
Players[1].Keylock[1]=false;
Players[1].Keys[1]=false;
}
if(state[SDL_SCANCODE_S])
{
	Players[1].Keys[2]=true;
}
else
{
Players[1].Keylock[2]=false;
Players[1].Keys[2]=false;
}
if(state[SDL_SCANCODE_A])
{
	Players[1].Keys[3]=true;
}
else
{
Players[1].Keylock[3]=false;
Players[1].Keys[3]=false;
}
if(state[SDL_SCANCODE_D])
{
	Players[1].Keys[4]=true;
}
else
{
Players[1].Keylock[4]=false;
Players[1].Keys[4]=false;
}
if(state[SDL_SCANCODE_LSHIFT])
{
	Players[1].Keys[5]=true;
}
else
{
Players[1].Keylock[5]=false;
Players[1].Keys[5]=false;
}
if(state[SDL_SCANCODE_UP])
{
	Players[1].Keys[6]=true;
}
else
{
Players[1].Keylock[6]=false;
Players[1].Keys[6]=false;
}
if(state[SDL_SCANCODE_DOWN])
{
	Players[1].Keys[7]=true;
}
else
{
Players[1].Keylock[7]=false;
Players[1].Keys[7]=false;
}
if(state[SDL_SCANCODE_LEFT])
{
	Players[1].Keys[8]=true;
}
else
{
Players[1].Keylock[8]=false;
Players[1].Keys[8]=false;
}
if(state[SDL_SCANCODE_RIGHT])
{
	Players[1].Keys[9]=true;
}
else
{
Players[1].Keylock[9]=false;
Players[1].Keys[9]=false;
}
if(state[SDL_SCANCODE_RCTRL])
{
	Players[1].Keys[10]=true;
}
else
{
Players[1].Keylock[10]=false;
Players[1].Keys[10]=false;
}
if(state[SDL_SCANCODE_RETURN])
{
	Players[1].Keys[11]=true;
}
else
{
Players[1].Keylock[11]=false;
Players[1].Keys[11]=false;
}
}

int DefPad=1;
bool GoDef=true;

int CheckHighScore(int CheckScore)
{
int Place=11;

for(int i=11; i>0; i--)
{
if(KCodeOn==false)
{
if(CheckScore>ScoreTable[Difficulty][i])
{
	Place=i;
}
}
else
{
if(CheckScore>ScoreTableB[Difficulty][i])
{
	Place=i;
}	
}
}
if(Place<11)
{
	
	//std::cout << "Made Place " << std::to_string(Place);
	if(KCodeOn==false)
	{
	for(int i=11; i>Place; i--)
	{
		ScoreTable[Difficulty][i]=ScoreTable[Difficulty][i-1];
		ScoreTableNames[Difficulty][i]=ScoreTableNames[Difficulty][i-1];
	}
	ScoreTable[Difficulty][Place]=Score;
	}
	else
	{
	for(int i=11; i>Place; i--)
	{
		ScoreTableB[Difficulty][i]=ScoreTableB[Difficulty][i-1];
		ScoreTableNamesB[Difficulty][i]=ScoreTableNamesB[Difficulty][i-1];
	}
	ScoreTableB[Difficulty][Place]=Score;
	}
}
return Place;	
}


int IniHighScoreList()
{
	Stack.Clear();
	for(int i=1; i<11; i++)
	{
		Boxes[i].content="Score";
		Boxes[i].Farbe={0, 0, 0};
		Objectlist[3].PosX=300;
		Objectlist[3].PosY=100*i;
		Objectlist[3].TextBoxShow=i;
		Objectlist[3].Layer=5; 
		Stack.Create(Objectlist[3]);
		Boxes[i+10].content="Score";
		Boxes[i+10].Farbe={0, 0, 0};
		Objectlist[3].PosX=1300;
		Objectlist[3].PosY=100*i;
		Objectlist[3].TextBoxShow=i+10;
		Objectlist[3].Layer=5; 
		Stack.Create(Objectlist[3]);
	}
		Boxes[22].content="Highscores";
		Boxes[22].Farbe={0, 0, 0};
		Objectlist[3].PosX=50;
		Objectlist[3].PosY=5;
		Objectlist[3].TextBoxShow=22;
		Objectlist[3].Layer=5; 
		Stack.Create(Objectlist[3]);
	Mode=4;
}

int IniEnterHighScore(int Placa)
{
	Stack.Clear();
	interface.Clear();
	EnteredName="";
	Placed=Placa;
	Searcher=0;
	Zeiger=0;
	
		Boxes[1].content="Enter Highscore";
		Boxes[1].Farbe={0, 0, 0};
		Boxes[1].W=900;
		Objectlist[3].PosX=300;
		Objectlist[3].PosY=100;
		Objectlist[3].TextBoxShow=1;
		Objectlist[3].Layer=5; 
		Stack.Create(Objectlist[3]);
		
		Boxes[2].content=EnteredName;
		Boxes[2].Farbe={0, 0, 0};
		Objectlist[3].PosX=300;
		Objectlist[3].PosY=400;
		Objectlist[3].TextBoxShow=2;
		Objectlist[3].Layer=5; 
		Stack.Create(Objectlist[3]);
		
			
		Boxes[3].content="Navigate with left Stick. Left Fire Button to choose. Right Fire Button to erase. Start to Confirm. You can open the list by using Left/Right in the main menu.";
		if(Keyboard==true)
		Boxes[3].content="Navigate with WASD. Left Fire Button to choose. Right Fire Button to erase. Return to Confirm. You can open the list by using Left/Right in the main menu.";
		Boxes[3].Farbe={0, 0, 0};
		Boxes[3].W=1400;
		Objectlist[3].PosX=300;
		Objectlist[3].PosY=700;
		
		Objectlist[3].TextBoxShow=3;
		Objectlist[3].Layer=5; 
		Stack.Create(Objectlist[3]);
		Mode=5;
		
}
float Adder=0;
float Adder2=0;

int ObjectLogic(void *in)
{

int starter=SDL_GetTicks();
while(running==true)
	{
	 if(Pause>0)Pause--;
	 if(Mode==4)
	 {
	 
	  int Show=1;
	  if(KCodeOn==true)
	    Show=2;
	   if(Show==1)
	   { 
	   for(int i=1; i<11; i++)
	   {
		  Boxes[i].content=ScoreTableNames[Table][i];
		  Boxes[i+10].content=std::to_string(ScoreTable[Table][i]);
	   }
	   }
	   else
	   {
			   for(int i=1; i<11; i++)
	   {
		  Boxes[i].content=ScoreTableNamesB[Table][i];
		  Boxes[i+10].content=std::to_string(ScoreTableB[Table][i]);
	   }   
	   }
	   Boxes[22].content="Highscores Level ";
	   Boxes[22].content.append(std::to_string(Table));
	   if(Show==2)
	    Boxes[22].content.append(" Blue Mode");
	 }
	 if(Mode==3)
	 {
		if(Keyboard==false)
		{
		 if(Locker>0)
		  Locker--;
		if(GoDef==true)
		{
		if(DefPad==1)
		{
		Boxes[1].content="Need to configure Gamepad! Press Left Axis Up";
		Boxes[1].Farbe={0, 0, 0};
		Objectlist[3].PosX=100;
		Objectlist[3].PosY=490;
		Objectlist[3].TextBoxShow=1;
		Objectlist[3].Layer=5; 
		Stack.Create(Objectlist[3]);
		GoDef=false;
		}	
		if(DefPad==2)
		{
		Boxes[1].content="Press Left Axis Left";
		Boxes[1].Farbe={0, 0, 0};
		GoDef=false;
		}
		if(DefPad==3)
		{
		Boxes[1].content="Press Right Axis Up";
		Boxes[1].Farbe={0, 0, 0};
		GoDef=false;
		}	
		if(DefPad==4)
		{
		Boxes[1].content="Press Right Axis Left";
		Boxes[1].Farbe={0, 0, 0};

		GoDef=false;
		}		
		if(DefPad==5)
		{
		Boxes[1].content="Press Left Shoulder Button";
		Boxes[1].Farbe={0, 0, 0};

		GoDef=false;
		}	
		if(DefPad==6)
		{
		Boxes[1].content="Press Right Shoulder Button";
		Boxes[1].Farbe={0, 0, 0};

		GoDef=false;
		}
		if(DefPad==7)
		{
		Boxes[1].content="Press Start Button";
		Boxes[1].Farbe={0, 0, 0};

		GoDef=false;
		}
		if(DefPad==8)
		{
			Mode=2;
			WriteSettings();
			IniMenu();
		}		
		}
		}
		else
		{
		if(GoDef==true)
		{
		Boxes[1].content="No Gamepad detected! If possible, connect a Gamepad and restart. Using WASD+LSHIFT and UP/LEFT/DOWN/RIGHT+RCTRL as fallback mode.";
		Boxes[1].Farbe={0, 0, 0};
		Boxes[1].W=1000;
		Objectlist[3].PosX=450;
		Objectlist[3].PosY=100;
		Objectlist[3].TextBoxShow=1;
		Objectlist[3].Layer=5; 
		Stack.Create(Objectlist[3]);
		GoDef=false;
		Locker=1000;
		}
		else
		{
		if(Locker==0)
		 {
			 Mode=2;
			 IniMenu();
			 WriteSettings();
		 }
		 else
		 Locker--;
		
		}
			
		}
	 }
	 if(Mode==1 && Pause==0)
	 {
		 if(Keyboard==true)
		 {
		   CheckKeyboard();
		   int AdderChecker=Adder;
		   int AdderChecker2=Adder2;
		   if(Players[1].Keys[1]==true)
		   {
			  if(interface.Ostack[1].PosY>0)interface.Ostack[1].PosY=interface.Ostack[1].PosY-3-Adder;
			  Adder=Adder+0.05;
		   }
		    if(Players[1].Keys[2]==true)
		   {
			  if(interface.Ostack[1].PosY<1030)interface.Ostack[1].PosY=interface.Ostack[1].PosY+3+Adder;
			  Adder=Adder+0.05;
		   }
		   if(Players[1].Keys[3]==true)
		   {
			  if(interface.Ostack[1].PosX>0)interface.Ostack[1].PosX=interface.Ostack[1].PosX-3-Adder;
			  Adder=Adder+0.05;
		   }
		   if(Players[1].Keys[4]==true)
		   {
			  if(interface.Ostack[1].PosX<910)interface.Ostack[1].PosX=interface.Ostack[1].PosX+3+Adder;
			  Adder=Adder+0.05;
		   }
		   if(Adder==AdderChecker)Adder=0;
		   if(Adder>2)Adder=2;
		   if(Players[1].Keys[5]==true)
		   {
			  Stack.Shoot(interface.Ostack[1].PosX+50, interface.Ostack[1].PosY+50);
				if(Sound1==false)
				{
						Sound1=true;
						
						Mix_HaltChannel(1);
						Mix_SetPanning(1, 255, 0);
						Mix_Volume(1, FXVolume);
						Mix_PlayChannel( 1, Sounds[1], -1 );
				}
			  SpawnEnemy(1);
			}
			else
			{
			Sound1=false;
			Mix_FadeOutChannel(1, 500);
			}
			
			if(Players[1].Keys[6]==true)
		   {
			  if(interface.Ostack[2].PosY>0)interface.Ostack[2].PosY=interface.Ostack[2].PosY-3-Adder2;
			  Adder2=Adder2+0.05;
		   }
		    if(Players[1].Keys[7]==true)
		   {
			  if(interface.Ostack[2].PosY<1030)interface.Ostack[2].PosY=interface.Ostack[2].PosY+3+Adder2;
			  Adder2=Adder2+0.05;
		   }
		   if(Players[1].Keys[8]==true)
		   {
			  if(interface.Ostack[2].PosX>910)interface.Ostack[2].PosX=interface.Ostack[2].PosX-3-Adder2;
			  Adder2=Adder2+0.05;
		   }
		   if(Players[1].Keys[9]==true)
		   {
			  if(interface.Ostack[2].PosX<1820)interface.Ostack[2].PosX=interface.Ostack[2].PosX+3+Adder2;
			  Adder2=Adder2+0.05;
		   }
		   if(Adder2==AdderChecker2)Adder2==0;
		   if(Adder2>2)Adder2=2;
		   if(Players[1].Keys[10]==true)
		   {
			  Stack.Shoot(interface.Ostack[2].PosX+50, interface.Ostack[2].PosY+50);
				if(Sound2==false)
				{
						Sound2=true;
						Mix_HaltChannel(2);
						Mix_SetPanning(2, 0, 255);
						Mix_Volume(2, FXVolume);
						Mix_PlayChannel( 2, Sounds[1], -1 );
				}
			  SpawnEnemy(1);
			}
			else
			{
			Sound2=false;
			Mix_FadeOutChannel(2, 500);
			}
		   
		 }
		if(Counter>0)
		{
				if(Mix_Playing(3)==0)
				{
						Mix_Volume(3, FXVolume);
						Mix_PlayChannel( 3, Sounds[2], -1 );
				}
		}
		else
		Mix_FadeOutChannel(3, 500);
if(EndGame==false)
{
	//Call Playerlogic
	PlayerLogic();
	Stack.Man();
	int r=rand()%50;
	if(r<=0+High)
	CreateLevel();
	
	//Handle the Rest.
}
else 
{
	if(CreateScoreShow==false)
	{
		            if(TutorialMade==true)
					WriteSettings();
					int Placement=CheckHighScore(Score);
					Boxes[1].content="You made ";
					Boxes[1].content.append(std::to_string(Score));
					Boxes[1].content.append(" on Level ");
					Boxes[1].content.append(std::to_string(Difficulty));
					if(KCodeOn==true)
					Boxes[1].content.append(" in Blue Mode");
					Boxes[1].Farbe={255, 255, 255};
					Objectlist[3].PosX=550;
					if(KCodeOn==true)
					Objectlist[3].PosX=Objectlist[3].PosX-200;
					Objectlist[3].PosY=490;
					Objectlist[3].TextBoxShow=1;
					Objectlist[3].Lifetime=500;
					Objectlist[3].Layer=5;
					Stack.Create(Objectlist[3]);
					CreateScoreShow=true;
					if(Placement!=11)
					{
						Boxes[2].content="Highscore!";
						Boxes[2].Farbe={255, 255, 255};
						Objectlist[3].PosX=700;
						Objectlist[3].PosY=750;
						Objectlist[3].TextBoxShow=2;
						Objectlist[3].Lifetime=500;
						Objectlist[3].Layer=5;
						Stack.Create(Objectlist[3]);
					}
						
					SDL_Delay(5000);
					if(Placement==11)
					IniMenu();
					else
					IniEnterHighScore(Placement);
	}
}
}
   if(Mode==2 || Mode==4 || Mode==5)
   {
		if(Keyboard==true)
	{
	
	 CheckKeyboard();
	 if(Players[1].Keys[1]==true && Players[1].Keylock[1]==false)
	 { 
		  Players[1].Keylock[1]=true;
		if(Mode!=5)
		{
		 
		  EnterKCode(1);
		 Menu--;
	   }
	   else
	   {
		    Zeiger=(Zeiger+27)%54;
	   }
	  
	   
	 }
	 if(Players[1].Keys[2]==true && Players[1].Keylock[2]==false)
	 { 
		 Players[1].Keylock[2]=true;
		if(Mode!=5)
		{
		 
		  EnterKCode(2);
		 Menu++;
	   }
	   else
	   {
		    Zeiger=(Zeiger+27)%54;
	   }
	 }
	  if(Players[1].Keys[3]==true && Players[1].Keylock[3]==false)
	 { 
		 Players[1].Keylock[3]=true;
		 if(Mode!=5  && MenuMode==1)
			{
			  IniHighScoreList();
			 if(Table==0)
			 Table=3;
			 else
			 Table--;
			 if(Table==0)
			 {
			  IniMenu();
			  Table=0;
			 }
			 EnterKCode(3);
		 }
		 else
		 {
			Zeiger--;
			if(Zeiger<0)Zeiger=53;
		 }
		
	 }
	 if(Players[1].Keys[4]==true && Players[1].Keylock[4]==false)
	 { 
		 Players[1].Keylock[4]=true;
		 	if(Mode!=5  && MenuMode==1)
				{
				  IniHighScoreList();
				 Table++;
				 if(Table==4)
				 {
				  IniMenu();
				  Table=0;
				 }
			 EnterKCode(4);
			}
			else
			{
			Zeiger++;
			if(Zeiger>53)Zeiger=0;
			}
		
	 }
	if(Players[1].Keys[5]==true && Players[1].Keylock[5]==false)
	 { 
		 Players[1].Keylock[5]=true;
		 MenuS=true;
	 }
	if(Players[1].Keys[6]==true && Players[1].Keylock[6]==false)
	 { 
		 Players[1].Keylock[6]=true;
		 MenuS1=true;
	 }
	 	if(Players[1].Keys[11]==true && Players[1].Keylock[11]==false)
	 { 
		 Players[1].Keylock[11]=true;
		 MenuS2=true;
	 }
	}   
   }
	if(Mode==2)
	{

	if(FreshStart>0)
	{
	 FreshStart--;
	 if(FreshStart==3000)
	  IniMenu();
	 if(FreshStart==0) 
	  IniMenu();
	}
	else
	{
	if(r<255)
	 r++;
	if(g<255)
	 g++;
	if(b<255)
	 b++;
	 if(MenuMode==1)
	 {
		 if(Menu>3)Menu=1;
		 if(Menu<1)Menu=3;
		for(int i=0; i<4; i++)
		{
		  if(i==Menu)
		   Boxes[1+i].Farbe={255, 0, 0};
		  else
		   Boxes[1+i].Farbe={0, 0, 0};
		}
		if(MenuS==true)
		{
		 MenuS=false;
		 if(Menu==1)
		  IniGame();
		 if(Menu==2)
		  IniMenu(true);
		 if(Menu==3)
		  running=false;
		}
	 }
	 if(MenuMode==2)
	 {
		 for(int i=0; i<7; i++)
		{
		  if(i==Menu)
		   Boxes[1+i].Farbe={255, 0, 0};
		  else
		   Boxes[1+i].Farbe={0, 0, 0};
		}
		 if(Menu>6)Menu=1;
		 if(Menu<1)Menu=6;
		Boxes[2].content="Difficulty ";
		Boxes[2].content.append(std::to_string(Difficulty));
		
		Boxes[3].content="Fullscreen ";
		if(FullScreen==true)
		Boxes[3].content.append(" On");
		else
		Boxes[3].content.append(" Off");
		
		Boxes[4].content="Tutorial ";
		if(Tutorial==true)
		Boxes[4].content.append(" On");
		else
		Boxes[4].content.append(" Off");
		
		
		Boxes[5].content="Sounds ";
		Boxes[5].content.append(std::to_string(FXVolume/12));
		
		Boxes[6].content="Music ";
		Boxes[6].content.append(std::to_string(MuVolume/12));
		
		if(MenuS==true)
		{
		MenuS=false;
		if(Menu==1)
		 {
			 
			 Difficulty++;
			 if(Difficulty>3)
			  Difficulty=1;
		 }
		 if(Menu==2)
		 {
			 if(FullScreen==true)
			  FullScreen=false;
			  else
			  FullScreen=true;
		 }
		 if(Menu==3)
		 {
			 if(Tutorial==true)
			  Tutorial=false;
			  else
			  Tutorial=true;
		 }
		 if(Menu==4)
		 {
			 FXVolume=FXVolume+10;
			 if(FXVolume>120)
			  FXVolume=0;
			  
			  Mix_Volume(1, FXVolume);
			   Mix_Volume(2, FXVolume);
			    Mix_Volume(3, FXVolume);
		 }
		 if(Menu==5)
		 {
			 MuVolume=MuVolume+10;
			 if(MuVolume>120)
			  MuVolume=0;
			  Mix_VolumeMusic(MuVolume);
			  
		 } 
		 if(Menu==6)
		 {
		  MenuS=false;
		  WriteSettings();
		  IniMenu();
		}
		}
		
	}
	 }
	 
	}
	if(Mode==5)
	{
		Boxes[2].content=EnteredName;
		Boxes[2].content.append(ABC.substr(Zeiger,1));
		
		if(MenuS==true)
		{
			EnteredName=Boxes[2].content;
			MenuS=false;
		}
		if(MenuS1==true && EnteredName.length()>0)
		{
			EnteredName=EnteredName.substr(0, (EnteredName.length()-1));
			MenuS1=false;
		}
		if(MenuS2==true)
		{
			EnteredName=Boxes[2].content;
			if(KCodeOn==false)
			ScoreTableNames[Difficulty][Placed]=EnteredName;
			else
			ScoreTableNamesB[Difficulty][Placed]=EnteredName;
			SaveScores();
			MenuS2=false;
			IniMenu();
		}
	}
	starter=SDL_GetTicks()-starter;
	if(starter<6)SDL_Delay(6-starter);
	starter=SDL_GetTicks();
	}
}


bool Slow1=false;
bool Slow2=false;
bool Slow3=false;
bool Slow4=false;
bool LockAxis=false;
bool aButton=false;
bool bButton=false;
bool cButton=false;
int LastAxis=-1;

int Events()
{

while( SDL_PollEvent( &event ) ){

switch( event.type ){
      case SDL_KEYDOWN:

        break;

      case SDL_KEYUP:
			if(event.key.keysym.sym==SDLK_ESCAPE)
			{
			if(Mode==1 || Mode==4 || MenuMode==2)
			  IniMenu();
			  else
			  if(Mode==2)
				running=false;
			}
			if(Mode==2 && FreshStart>3000)
			  FreshStart=3001;
			if(Mode==2 && FreshStart>0)
			  FreshStart=1;
			 if(Mode==3 && Locker>0)
			  Locker=1;
		break;
	if(PadMode==2)
		{
	  case SDL_JOYHATMOTION:
			if(event.jhat.value==SDL_HAT_UP)Players[event.jhat.which].HatUp=true;
			if(event.jhat.value==SDL_HAT_CENTERED)Players[event.jhat.which].HatUp=false;
        break;
      
        case SDL_JOYAXISMOTION:
          if(Mode==2 && FreshStart>3000)
          FreshStart=3001;
         if(Mode==2 && FreshStart>0)
          FreshStart=1;
         if(Mode==3 && Locker==0)
          {
			 
			  if(LockAxis==false && event.jaxis.value!=0 && event.jaxis.value!=LastAxis && DefPad<5)
			  {
			   Locker=30;
			  LastAxis=event.jaxis.value;
			  //std::cout << "Axis Motion Set " << DefPad << " " << std::to_string(event.jaxis.axis) << std::endl;
			  LockAxis=true;
			  Players[1].Axis[DefPad]=event.jaxis.axis;
			  DefPad++;
			  GoDef=true;
			  }
			    if(LockAxis==true && event.jaxis.value==0)
			  {
				  LockAxis=false;
			  }
		  }
		  break;
		case SDL_JOYBUTTONDOWN:
		if(Mode==2 && FreshStart>3000)
			  FreshStart=3001;
		 if(Mode==2 && FreshStart>0)
			  FreshStart=1;
		 if(Mode==3 && DefPad>4  && Locker==0)
		 {
			 Locker=30;
		   if(DefPad==7)
		   {
			
		   Players[1].Buttons[3]=event.jbutton.button;
		   DefPad++;
		   GoDef=true;
		   //std::cout << "Button Set " << std::to_string(event.jbutton.button) << std::endl;
			}
		   if(DefPad==6)
		   {
			
		   Players[1].Buttons[2]=event.jbutton.button;
		   DefPad++;
		   GoDef=true;
		   //std::cout << "Button Set " << std::to_string(event.jbutton.button) << std::endl;
			}
		  if(DefPad==5)
		  {
		   Players[1].Buttons[1]=event.jbutton.button;
		   DefPad++;
		   GoDef=true;
		   //std::cout << "Button Set " << std::to_string(event.jbutton.button) << std::endl;
			}
			

		 }
        break; 
		}
        if(PadMode==1)
		{
		case SDL_CONTROLLERAXISMOTION:	
		   if(Mode==2 && FreshStart>3000)
          FreshStart=3001;
         if(Mode==2 && FreshStart>0)
          FreshStart=1;
          break;
		case SDL_CONTROLLERBUTTONDOWN:
		 if(Mode==2 && FreshStart>3000)
          FreshStart=3001;
		 if(Mode==2 && FreshStart>0)
			  FreshStart=1;
			  break; 
		} 
		}
		





}
if(PadMode==2)
{
for(int i=0; i<SDL_NumJoysticks (); i++)
{
Players[i].AxX = SDL_JoystickGetAxis(Pad1[i], Players[1].Axis[2]);
Players[i].AxY = SDL_JoystickGetAxis(Pad1[i], Players[1].Axis[1]);
interface.Ostack[1].PosX=(480-50)+((Players[i].AxX/32767)*480);
interface.Ostack[1].PosY=((1050/2)-50)+((Players[i].AxY/32767)*520);

Players[i].AxX = SDL_JoystickGetAxis(Pad1[i], Players[1].Axis[4]);
Players[i].AxY = SDL_JoystickGetAxis(Pad1[i], Players[1].Axis[3]);

if(Mode==1)
{
interface.Ostack[2].PosX=(1440-50)+((Players[i].AxX/32767)*480);
interface.Ostack[2].PosY=((1050/2)-50)+((Players[i].AxY/32767)*520);
//std::cout << "X: " <<Players[i].AxX << "Y: " << Players[i].AxY << std::endl;
int buttonPress=SDL_JoystickGetButton(Pad1[i], Players[1].Buttons[1]);
if(buttonPress==1 && Pause==0)
{
  Stack.Shoot(interface.Ostack[1].PosX+50, interface.Ostack[1].PosY+50);
	if(Sound1==false)
	{
			Sound1=true;
			Mix_HaltChannel(1);
			Mix_SetPanning(1, 255, 0);
			Mix_Volume(1, FXVolume);
			Mix_PlayChannel( 1, Sounds[1], -1 );
	}
  SpawnEnemy(1);
}
else
{
Sound1=false;
Mix_FadeOutChannel(1, 500);
}

int buttonPress2=SDL_JoystickGetButton(Pad1[i], Players[1].Buttons[2]);
if(buttonPress2==1 && Pause==0)
{
	SpawnEnemy(1);
	if(Sound2==false)
	{
	 Sound2=true;
	 Mix_HaltChannel(2);
	 Mix_SetPanning(2, 0, 255);
	 Mix_Volume(2, FXVolume);
	Mix_PlayChannel( 2, Sounds[1], -1 );
	}
  Stack.Shoot(interface.Ostack[2].PosX+50, interface.Ostack[2].PosY+50);
}
else
{
Sound2=false;
Mix_FadeOutChannel(2, 500);
}
int buttonPress3=SDL_JoystickGetButton(Pad1[i], Players[1].Buttons[3]);
if(buttonPress3==1)
{
IniMenu();
}
/*
int buttonPress3=SDL_JoystickGetButton(Pad1[i], 1);
if(buttonPress3==1)
{
	High=High+0.1;
	std::cout << "H: " << High << std::endl;
}
else
{
if(High>0)
High=High-0.1;
} */

}
if(Mode==2 || Mode==4 || Mode==5)
{
Players[i].AxX = SDL_JoystickGetAxis(Pad1[i], Players[1].Axis[1]);
Players[i].AxY = SDL_JoystickGetAxis(Pad1[i], Players[1].Axis[2]);
if(Players[i].AxX<-20000)
{
if(Slow1==false)
 {
	 Slow1=true;
 if(Mode!=5)
 {
 Menu--;
 EnterKCode(1);
 
 }
 else
 {
  Zeiger=(Zeiger+27)%54;
 }
 }
}
else
Slow1=false;

if(Players[i].AxX>20000)
{
if(Slow2==false)
{
  Slow2=true;
 if(Mode!=5)
 {
 Menu++;	
 EnterKCode(2);

 }
 else
 {
	 Zeiger=(Zeiger+27)%54;
 }
}
}
else
Slow2=false;

if(Players[i].AxY<-20000)
{
if(Slow3==false && FreshStart==0)
{
if(Mode!=5  && MenuMode==1)
{
  IniHighScoreList();
 if(Table==0)
 Table=3;
 else
 Table--;
 if(Table==0)
 {
  IniMenu();
  Table=0;
 }
 EnterKCode(3);
}
else
{
	Zeiger--;
	if(Zeiger<0)Zeiger=53;
}
 Slow3=true;
}
}
else
Slow3=false;

if(Players[i].AxY>20000)
{
if(Slow4==false && FreshStart==0)
{
if(Mode!=5  && MenuMode==1)
{
  IniHighScoreList();
 Table++;
 if(Table>3)
 {
	 Table=0;
	 IniMenu();
 }	
 EnterKCode(4);
}
else
{

	Zeiger++;
	if(Zeiger>53)Zeiger=0;
}
 Slow4=true;
}
}
else
Slow4=false;


int buttonPress3=SDL_JoystickGetButton(Pad1[i], Players[1].Buttons[1]); 
if((buttonPress3==1) && (aButton==false))
{
	MenuS=true;
	aButton=true;
}
else
{
 MenuS=false;
}
if(buttonPress3==0)
 aButton=false;
 
if(Mode==5)
{
buttonPress3=SDL_JoystickGetButton(Pad1[i], Players[1].Buttons[2]); 
if((buttonPress3==1) && (bButton==false))
{
	MenuS1=true;
	bButton=true;
}
else
{
 MenuS1=false;
}
if(buttonPress3==0)
 bButton=false;	
 
  buttonPress3=SDL_JoystickGetButton(Pad1[i], Players[1].Buttons[2]); 
if((buttonPress3==1) && (cButton==false))
{
	MenuS2=true;
	cButton=true;
}
else
{
 MenuS2=false;
}
if(buttonPress3==0)
 cButton=false;	
	
}

}
}
}
if(PadMode==1)
{

int i=1;

Players[i].AxX = SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_LEFTX );
Players[i].AxY = SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_LEFTY );
//std::cout << "X: " <<Players[i].AxX << "Y: " << Players[i].AxY << std::endl;
int TheMax=32767;
if(DualShockHack==true)
{
	if(Players[i].AxX<100 && Players[i].AxX > -100)
	 Players[i].AxX=0;
	if(Players[i].AxY<100 && Players[i].AxY > -100)
	 Players[i].AxY=0;
	 
	 TheMax=24000;
	 if(Players[i].AxX>TheMax)
	  Players[i].AxX=TheMax;
	 if(Players[i].AxX<(TheMax*-1))
	  Players[i].AxX=TheMax*-1;
	 if(Players[i].AxY>TheMax)
	  Players[i].AxY=TheMax;
	 if(Players[i].AxY<(TheMax*-1))
	  Players[i].AxY=TheMax*-1;
}
interface.Ostack[1].PosX=(480-50)+((Players[i].AxX/TheMax)*480);
interface.Ostack[1].PosY=((1050/2)-50)+((Players[i].AxY/TheMax)*520);

Players[i].AxX = SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_RIGHTX );
Players[i].AxY = SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_RIGHTY );
if(DualShockHack==true)
{
	if(Players[i].AxX<100 && Players[i].AxX > -100)
	 Players[i].AxX=0;
	if(Players[i].AxY<100 && Players[i].AxY > -100)
	 Players[i].AxY=0;
	 TheMax=24000;
	 if(Players[i].AxX>TheMax)
	  Players[i].AxX=TheMax;
	 if(Players[i].AxX<(TheMax*-1))
	  Players[i].AxX=TheMax*-1;
	 if(Players[i].AxY>TheMax)
	  Players[i].AxY=TheMax;
	 if(Players[i].AxY<(TheMax*-1))
	  Players[i].AxY=TheMax*-1;
}

if(Mode==1)
{
interface.Ostack[2].PosX=(1440-50)+((Players[i].AxX/TheMax)*480);
interface.Ostack[2].PosY=((1050/2)-50)+((Players[i].AxY/TheMax)*520);
//std::cout << "X: " <<Players[i].AxX << "Y: " << Players[i].AxY << std::endl;
int buttonPress=SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_LEFTSHOULDER );
if(buttonPress==1 && Pause==0)
{
  Stack.Shoot(interface.Ostack[1].PosX+50, interface.Ostack[1].PosY+50);
	if(Sound1==false)
	{
			Sound1=true;
			Mix_HaltChannel(1);
			Mix_SetPanning(1, 255, 0);
			Mix_Volume(1, FXVolume);
			Mix_PlayChannel( 1, Sounds[1], -1 );
	}
  SpawnEnemy(1);
}
else
{
Sound1=false;
Mix_FadeOutChannel(1, 500);
}

int buttonPress2=SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_RIGHTSHOULDER );
if(buttonPress2==1 && Pause==0)
{
	SpawnEnemy(1);
	if(Sound2==false)
	{
	 Sound2=true;
	 Mix_HaltChannel(2);
	 Mix_SetPanning(2, 0, 255);
	 Mix_Volume(2, FXVolume);
	Mix_PlayChannel( 2, Sounds[1], -1 );
	}
  Stack.Shoot(interface.Ostack[2].PosX+50, interface.Ostack[2].PosY+50);
}
else
{
Sound2=false;
Mix_FadeOutChannel(2, 500);
}
int buttonPress3=SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_START  );
if(buttonPress3==1)
{
IniMenu();
}
/*
int buttonPress3=SDL_JoystickGetButton(Pad1[i], 1);
if(buttonPress3==1)
{
	High=High+0.1;
	std::cout << "H: " << High << std::endl;
}
else
{
if(High>0)
High=High-0.1;
} */

}
if(Mode==2 || Mode==4 || Mode==5)
{
Players[i].AxX = SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_LEFTY );
Players[i].AxY = SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_LEFTX );
if(Players[i].AxX!=0 || Players[i].AxY!=0)
//std::cout << Players[i].AxX << "|" << Players[i].AxY << std::endl;
if(Players[i].AxX<-20000)
{
if(Slow1==false)
 {
	 Slow1=true;
 if(Mode!=5)
 {
 Menu--;

 EnterKCode(1);
 }
 else
 Zeiger=(Zeiger+27)%54;
 }
}
else
Slow1=false;

if(Players[i].AxX>20000)
{
if(Slow2==false)
{
 Slow2=true;
 if(Mode!=5)
 {
 Menu++;	

 EnterKCode(2);
}
else
Zeiger=(Zeiger+27)%54;
}
}
else
Slow2=false;

if(Players[i].AxY<-20000)
{
if(Slow3==false && FreshStart==0)
{
if(Mode!=5 && MenuMode==1)
{
 IniHighScoreList();
 if(Table==0)
 Table=3;
 else
 Table--;
 if(Table==0)
 {
  IniMenu();
  Table=0;
 }
 EnterKCode(3);	
}
else
{
	
	Zeiger--;
	if(Zeiger<0)Zeiger=53;	
}
 Slow3=true;
}
}
else
Slow3=false;

if(Players[i].AxY>20000)
{
if(Slow4==false && FreshStart==0)
{
if(Mode!=5  && MenuMode==1)
{
 IniHighScoreList();
 Table++;
 if(Table>3)
 {
	 Table=0;
	 IniMenu();
 }
 EnterKCode(4);	
}
else
{
	Zeiger++;
	if(Zeiger>53)Zeiger=0;
}
 Slow4=true;
}
}
else
Slow4=false;


int buttonPress3=SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_LEFTSHOULDER );
if((buttonPress3==1) && (aButton==false))
{
	
	MenuS=true;
	aButton=true;
}
else
{
 MenuS=false;
}
if(buttonPress3==0)
 aButton=false;
}

if(Mode==5)
{
int buttonPress3=SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_RIGHTSHOULDER );
if((buttonPress3==1) && (bButton==false))
{
	MenuS1=true;
	bButton=true;
}
else
{
 MenuS1=false;
}
if(buttonPress3==0)
 bButton=false;	
 
 buttonPress3=SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_START );
if((buttonPress3==1) && (cButton==false))
{
	MenuS2=true;
	cButton=true;
}
else
{
 MenuS2=false;
}
if(buttonPress3==0)
 cButton=false;	
	
}


}

}

int DefBoxes()
{
	Boxes[1].Font=1;
	Boxes[1].content="Hallo";
}

int main()
{
	loadSettings("Settings.txt");
	iniSDL(AA);
	srand (time(NULL));
	
	int in;
    loadScore("Scores.txt");
   SaveScores();
	LoadSounds();
	loadImages("Liste.txt");
	DefBoxes();
	SDL_Thread* Logic = SDL_CreateThread( ObjectLogic, "Logic", (void*)in);
	SDL_Thread* Graphic = SDL_CreateThread(GraphicHandler, "Graphic", (void*)in);
	IniMenu();
	while(running==true)
	{
		if(FreshStart<3500)
		Events();
		//std::cout << "Have you seen the mystic Queen, riding in her Limousine?" << std::endl;
		MusicMan();
		SDL_Delay(16);
	
	
	}
	SDL_Quit();
	return 0;
}

